#include <iostream>
#include <map>
#include <string>
using namespace std;

int main()
{
    /* create map / associative array
     * - keys are strings
     * - values are floats
     */
    typedef map<string,float> StringFloatMap;

    StringFloatMap variableTable;      // create empty container


	
	
	
	
	// insert some new pairs
    variableTable["BASF"] = 369.50;
    variableTable["VW	"] = 413.50;
    variableTable["Daimler"] = 819.00;
    variableTable["BMW"] = 834.00;
    variableTable["Siemens"] = 842.20;

    // print all pairs
    StringFloatMap::iterator pos;
    for (pos = variableTable.begin(); pos != variableTable.end(); ++pos) {
        cout << "variable name (key): " << pos->first << "\t"	//first is the key in the pair
             << "value: " << pos->second << endl;				//second is the value in the pair	
    }
    cout << endl;





    // modify the values of some pairs
    variableTable["BASF"] = 999.50;
    variableTable["BMW"] = 999.00;

   // print all pairs again
    for (pos = variableTable.begin(); pos != variableTable.end(); ++pos) {
        cout << "variable name (key): " << pos->first << "\t"
             << "value: " << pos->second << endl;
    }
    cout << endl;





    // Erase some pairs
	variableTable.erase("BASF");
	variableTable.erase("BMW");

    // print all pairs again 
    for (pos = variableTable.begin(); pos != variableTable.end(); ++pos) {
		cout << "variable name (key): " << pos->first << "\t"
             << "value: " << pos->second << endl;
    }
   cout << endl;




    /* rename key from "VW" to "Volkswagen"
     * - only provided by exchanging element
     */
    variableTable["Volkswagen"] = variableTable["VW	"];
 	variableTable.erase("VW	");

    // print all pairs again 
    for (pos = variableTable.begin(); pos != variableTable.end(); ++pos) {
        cout << "variable name (key): " << pos->first << "\t"
             << "value: " << pos->second << endl;
    }
	cout << endl;

}
